      subroutine phase6new(r,p1,p2,p3,p4,p5,p6,p7,p8,wt,*)
      implicit none
      include 'constants.f'
      include 'heavyflav.f'
      include 'masses.f'
      include 'mxdim.f'
      include 'debug.f'
      include 'process.f'
c---- generate phase space for 2-->6 process
c---- r(mxdim),p1(4),p2(4) are inputs reversed in sign 
c---- from physical values 
c---- phase space for -p1-p2 --> p3+p4+p5+p6+p7+p8
c---- with all 2 pi's (ie 1/(2*pi)^8)
      double precision r(mxdim)
      double precision p1(4),p2(4),p3(4),p4(4),p5(4),p6(4),p7(4),p8(4)
      double precision p12(4),p34(4),p56(4),p3456(4),p78(4)
      double precision wt,wt3456,wt34,wt56,wt78,wt0,wt12,tmp
      double precision mass2,width2,mass3,width3
      integer n2,n3,n2old,n3old
      common/breit/n2,n3,mass2,width2,mass3,width3
      integer j
      parameter(wt0=1d0/twopi**4)

      do j=1,4
      p12(j)=-p1(j)-p2(j)
      enddo


      n2=0
      mass3=hmass
      width3=hwidth

      call phi1_2(r(1),r(2),r(3),r(4),p12,p78,p3456,wt12,*99)


      n2=1
      mass3=wmass
      width3=wwidth

      call phi1_2(r(5),r(6),r(7),r(8),p3456,p34,p56,wt3456,*99)

CC    p34->p3+p4

      call phi3m0(r(11),r(12),p34,p3,p4,wt34,*99)

CC    p56->p5+p6

      call phi3m0(r(13),r(14),p56,p5,p6,wt56,*99)

CC    p78->p7+p8

      call phi3m0(r(15),r(16),p78,p7,p8,wt78,*99)



      tmp=dsqrt(p78(4)**2-p78(1)**2-p78(2)**2-p78(3)**2) 
c      if(tmp.lt.10d0)write(*,*)tmp      

      wt=wt0*wt12*wt3456*wt34*wt56*wt78
      if (debug) write(6,*) 'wt in phase4',wt
      return
 
 99   wt=0d0
      return 1
      end
